
//+------------------------------------------------------------------+
//|                                               Alligator+Kerst.mq4
//|                      Copyright  2010, khodakvv                  |
//|                                        khodakvv@mail.ru          |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, khodakvv"
#property link      "http://khodakvv@mail.ru"

//---- input parameters
extern string separator1 = "***   ***";
extern int    jaw_period = 13;
extern int    jaw_shift = 8;
extern int    teeth_period = 8;
extern int    teeth_shift = 5;
extern int    lips_period = 5;
extern int    lips_shift = 3;
extern double herstnumber = 0.6;
extern string separator2 = "***   ***";
extern double Lots = 1;
extern int    StopLoss = 15;
extern int    TakeProfit = 13;
extern int    slippage = 3;
extern int    magic = 614193411933;

//----
int tikbuy, tiksell, i;


//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
int init()
   {

//+------------------------------------------------------------------+
   if(Period() == 1)magic++;
   if(Period() == 5)magic=magic+2;
   if(Period() == 15)magic=magic+3;
   if(Period() == 30)magic=magic+4;
   if(Period() == 60)magic=magic+5;
   if(Period() == 240)magic=magic+6;
   if(Period() == 1440)magic=magic+7;
   if(Period() == 10080)magic=magic+8; 
//+------------------------------------------------------------------+   
     
      for(i=1; i<=OrdersTotal(); i++)          
           {
              if (OrderSelect(i-1,SELECT_BY_POS)) 
                 {                                       
                   if (OrderSymbol()!=Symbol())continue;
                   if (OrderMagicNumber()!= magic)continue;
                   if (OrderType()== 0)
                      {
                      tikbuy = OrderTicket();
                      
                      }
                   if (OrderType()== 1)
                      {
                      tiksell = OrderTicket();
                      
                      } 
                 }     
           }              

    
   
   }

//+------------------------------------------------------------------+
int start()
 {  






//+------------------------------------------------------------------+
    bool buys=CheckOrders(0);
    bool sells=CheckOrders(1);
//+------------------------------------------------------------------+

//+----------------------------------------------------------------+   

double lips1 = iAlligator(NULL, 0, jaw_period, jaw_shift, teeth_period, teeth_shift, lips_period, lips_shift, MODE_SMMA, PRICE_MEDIAN, MODE_GATORLIPS, 1);
double lips2 = iAlligator(NULL, 0, jaw_period, jaw_shift, teeth_period, teeth_shift, lips_period, lips_shift, MODE_SMMA, PRICE_MEDIAN, MODE_GATORLIPS, 2);
double jaws1 = iAlligator(NULL, 0, jaw_period, jaw_shift, teeth_period, teeth_shift, lips_period, lips_shift, MODE_SMMA, PRICE_MEDIAN, MODE_GATORJAW, 1);
double jaws2 = iAlligator(NULL, 0, jaw_period, jaw_shift, teeth_period, teeth_shift, lips_period, lips_shift, MODE_SMMA, PRICE_MEDIAN, MODE_GATORJAW, 2);
double teeth1 = iAlligator(NULL, 0, jaw_period, jaw_shift, teeth_period, teeth_shift, lips_period, lips_shift, MODE_SMMA, PRICE_MEDIAN, MODE_GATORTEETH, 1);
double teeth2 = iAlligator(NULL, 0, jaw_period, jaw_shift, teeth_period, teeth_shift, lips_period, lips_shift, MODE_SMMA, PRICE_MEDIAN, MODE_GATORTEETH, 2);

//+--------------------------------------------------------------------+ 
while(true)
     {
       if (buys)break;
       
       if (lips1<=jaws1)break;
       if (lips2>jaws2)break;
       if (iCustom(NULL,0,"Herst3",0,1)<=herstnumber)break;
       
                             
                               
                              tikbuy = OPENBUY(Lots,slippage,Bid-StopLoss*Point,Ask+TakeProfit*Point,magic);
                              if(tikbuy>0)
                                 {
                                   int currenttime = TimeCurrent();
                                   while(true)
                                        {
                                         RefreshRates();
                                         if ((TimeCurrent()- currenttime) < 60*Period())continue;
                                         break; 
                                        
                                        }
                                   
                                   
                                                                             
                                 }
                              return;    
                           
  }
//+------------------------------------------------------------------+ 
while(true)
     {
       
       if (sells)break;
       if (teeth1>=jaws1)break;
       if (teeth2<jaws2)break;
       if (iCustom(NULL,0,"Herst3",0,1)<=herstnumber)break;
       
                         
                              
                              tiksell = OPENSELL(Lots,slippage,Ask+StopLoss*Point,Bid-TakeProfit*Point,magic);
                              if(tiksell>0)
                                   {
                                   currenttime = TimeCurrent();
                                   while(true)
                                        {
                                         RefreshRates();
                                         if ((TimeCurrent()- currenttime) < 60*Period())continue;
                                         break; 
                                        
                                        }
                                             
                                   }
                              return;
     }
 //+------------------------------------------------------------------+ 
  
}         
//+------------------------------------------------------------------+
int Fun_Error (int Error)                        // -  
  {
   switch(Error)
     {                                          //              
      case  4: Alert("  .   ..");
         Sleep(3000);                           //  
         return(1);                             //   
      case 135:Alert(" .   ..");
         RefreshRates();                        //  
         return(1);                             //   
      case 136:Alert(" .   ..");
         while(RefreshRates()==false)           //   
            Sleep(1);                           //   
         return(1);                             //   
      case 137:Alert(" .   ..");
         Sleep(3000);                           //  
         return(1);                             //   
      case 146:Alert("  .  ..");
         Sleep(1000);                            //  
         return(1);                             //   
         //  
      case  2: Alert(" .");
         return(0);                             //   
      case 64: Alert(" .");
         return(0);                             //   
      case 133:Alert(" .");
         return(0);                             //   
      case 134:Alert("    .");
         return(0);                             //   
      default: Alert("  ",Error); //     
         return(0);                             //   
     }
  }
//--------------------------------------------------------------
 //---------------------------------------------------                                
int OPENBUY (double Lots,int slippage,double StopLoss,double TakeProfit1, int magic)
   {
    while (true)   
        
          {
             RefreshRates();                        //  
             Alert("  Buy.  ..");
             int Ticket1=OrderSend(Symbol(),OP_BUY,Lots,Ask,slippage,StopLoss,TakeProfit1,0,magic,0,Green);           
             if (Ticket1 > 0)
                {
                
                Alert ("  Buy ",Ticket1);
                break;
                } 
                else if (Fun_Error(GetLastError())==1) 
                        {
                        continue;
                        }
                     else 
                        {
                        return(0);
                        }     
           }
                
    
    return (Ticket1);           
 }
//---------------------------------------------------
//---------------------------------------------------
int OPENSELL (double Lots,int slippage,double StopLoss,double TakeProfit1, int magic)
  { 
   while (true)   
        
          {
             RefreshRates();                        //  
             Alert("  Sell.  ..");
             int Ticket3=OrderSend(Symbol(),OP_SELL,Lots,Bid,slippage,StopLoss,TakeProfit1,0,magic,0,Green);           
             if (Ticket3 > 0)
                {
                
                Alert ("  Sell ",Ticket3);
                break;
                } 
                else if (Fun_Error(GetLastError())==1) 
                        {
                        continue;
                        }
                     else
                      {
                      return(0);
                      }     
           }
                
    
    return (Ticket3); 
  
}
//---------------------------------------------------
//--------------------------------------------------------------
int CheckOrders(int type)
    {
                              
       bool check = false;                                 
        for(int i=1; i<=OrdersTotal(); i++)          
           {
              if (OrderSelect(i-1,SELECT_BY_POS)) 
                 {                                       
                   if (OrderSymbol()!=Symbol())continue;
                   if (OrderMagicNumber()==magic && OrderType()== type)
                      {
                      check = true;
                      break;
                      }
                 }
           }
       return (check);                
    }                    
//--------------------------------------------------------------


 

